# https://www.freecodecamp.org/news/postgresql-in-python/
# https://www.datacamp.com/tutorial/tutorial-postgresql-python
import psycopg2
import dotenv
import os 
# from icecream import ic


def main():
    print("Connecting to the PostgreSQL database...")
    conn = connect()
    cursor = conn.cursor()
    print("Creating a table")
    # SERIAL: auto-incrementing integer
    # VARCHAR: variable-length character string
    # (50) Set the maximum length of the course_name column to 50 characters.
    # UNIQUE: ensure that all values in the course_name column are unique.
    # NOT NULL: ensure that the course_name column cannot have NULL values.
    # (100) Set the maximum length of the course_instructor column to 100 characters.
    # (20) Set the maximum length of the topic column to 20 characters.
    cursor.execute("""CREATE TABLE datacamp_courses(
            course_id SERIAL PRIMARY KEY,
            course_name VARCHAR (50) UNIQUE NOT NULL,
            course_instructor VARCHAR (100) NOT NULL,
            topic VARCHAR (20) NOT NULL);
            """)
    print("Committing the table to the database...")
    print("Closing the connection adn the cursor...")
    cursor.close()
    conn.close()
    # cursor.execute("SELECT * FROM DB_table WHERE id = 1")


def connect():
    dotenv.load_dotenv()
    conn = psycopg2.connect(
        database=os.getenv('POSTGRES_DB'),
        host=os.getenv('DB_HOST'),
        port=os.getenv('DB_PORT'),
        user=os.getenv('POSTGRES_USER'),
        password=os.getenv('POSTGRES_PASSWORD')
    )
    return conn

if __name__ == "__main__":
    main()